alter table paciente add pac_genero varchar(2); --[lode]

insert into atualizacoes(atu_nome) values ('v23020001_090223.sql'); --[lode]

create table identidadegenero (
       ige_codigo           integer not null,
       ige_descricao        varchar(80)
);--[lode]

create unique index xpkidentidadegenero on identidadegenero (
       ige_codigo
);--[lode]

alter table identidadegenero add primary key (ige_codigo);--[lode]

alter table paciente drop pac_genero;

alter table paciente add pac_genero integer;

insert into identidadegenero(ige_codigo, ige_descricao) values (1,'Não informado');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (2,'Binário');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (3,'Crossdresser');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (4,'Cross gender');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (5,'Feminino');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (6,'Gênero-fluido');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (7,'Homem em Transição');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (8,'Homem trans');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (9,'Indeterminado');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (10,'Masculino');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (11,'Mulher em Transição');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (12,'Mulher trans');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (13,'Não-binário');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (14,'Pangênero');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (15,'Terceiro sexo');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (16,'Transgênero');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (17,'Transgênero não-binário');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (18,'Transexual');--[lode]
insert into identidadegenero(ige_codigo, ige_descricao) values (19,'Travesti');--[lode]

insert into atualizacoes(atu_nome) values ('v23020002_160223.sql'); --[lode]

alter table requisicaoweb add rew_areaproduto varchar(10); --[lode]

insert into atualizacoes(atu_nome) values ('v23020003_150323.sql'); --[lode]

alter table requisicao add req_nomesautorizados varchar(5000); --[lode]

insert into atualizacoes(atu_nome) values ('v23020004_150323.sql'); --[lode]

set session_replication_role=replica;
alter table requisicao alter req_lacreproduto type varchar(25); --[lode]
alter table requisicao alter req_lacreprodutocontra type varchar(25); --[lode]
alter table requisicao alter req_lacreprodutocontraempresa type varchar(25); --[lode]
alter table requisicao alter req_numeroregistroproduto type varchar(25); --[lode]

alter table requisicaoweb alter rew_lacreproduto type varchar(25); --[lode]
alter table requisicaoweb alter rew_numeroregistroproduto type varchar(25); --[lode]

set session_replication_role=origin;

insert into atualizacoes(atu_nome) values ('v23020005_280323.sql'); --[lode]